/* AppContextMenu.c generated by valac 0.54.6, the Vala compiler
 * generated from AppContextMenu.vala, do not modify */

/*
 * Copyright 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include "slingshot.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gdesktopappinfo.h>
#include <gtk/gtk.h>
#include <plank.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

enum  {
	SLINGSHOT_APP_CONTEXT_MENU_0_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY,
	SLINGSHOT_APP_CONTEXT_MENU_NUM_PROPERTIES
};
static GParamSpec* slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
enum  {
	SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL,
	SLINGSHOT_APP_CONTEXT_MENU_NUM_SIGNALS
};
static guint slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_NUM_SIGNALS] = {0};

struct _SlingshotAppContextMenuPrivate {
	gchar* _desktop_id;
	gchar* _desktop_path;
	GDesktopAppInfo* app_info;
	gboolean has_system_item;
	gchar* appstream_comp_id;
	GtkMenuItem* uninstall_menuitem;
	GtkMenuItem* appcenter_menuitem;
	gboolean docked;
};

struct _Block7Data {
	int _ref_count_;
	SlingshotAppContextMenu* self;
	gchar* action;
};

static gint SlingshotAppContextMenu_private_offset;
static gpointer slingshot_app_context_menu_parent_class = NULL;
static PlankDBusClient* slingshot_app_context_menu_plank_client;
static PlankDBusClient* slingshot_app_context_menu_plank_client = NULL;
static GType slingshot_app_context_menu_type_id = 0;

static void slingshot_app_context_menu_uninstall_menuitem_activate (SlingshotAppContextMenu* self);
static void slingshot_app_context_menu_plank_menuitem_activate (SlingshotAppContextMenu* self);
static gchar* slingshot_app_context_menu_get_desktop_uri (SlingshotAppContextMenu* self);
static GObject * slingshot_app_context_menu_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _slingshot_app_context_menu_____lambda35_ (Block7Data* _data7_);
static void __slingshot_app_context_menu_____lambda35__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                        gpointer self);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _slingshot_app_context_menu_plank_menuitem_activate_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                                 gpointer self);
static void slingshot_app_context_menu_finalize (GObject * obj);
static void _vala_slingshot_app_context_menu_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_slingshot_app_context_menu_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static gssize _vala_array_length (gpointer array);

static inline gpointer
slingshot_app_context_menu_get_instance_private (SlingshotAppContextMenu* self)
{
	return G_STRUCT_MEMBER_P (self, SlingshotAppContextMenu_private_offset);
}

SlingshotAppContextMenu*
slingshot_app_context_menu_construct (GType object_type,
                                      const gchar* desktop_id,
                                      const gchar* desktop_path)
{
	SlingshotAppContextMenu * self = NULL;
	g_return_val_if_fail (desktop_id != NULL, NULL);
	g_return_val_if_fail (desktop_path != NULL, NULL);
	self = (SlingshotAppContextMenu*) g_object_new (object_type, "desktop-id", desktop_id, "desktop-path", desktop_path, NULL);
	return self;
}

SlingshotAppContextMenu*
slingshot_app_context_menu_new (const gchar* desktop_id,
                                const gchar* desktop_path)
{
	return slingshot_app_context_menu_construct (SLINGSHOT_TYPE_APP_CONTEXT_MENU, desktop_id, desktop_path);
}

static void
slingshot_app_context_menu_uninstall_menuitem_activate (SlingshotAppContextMenu* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL], 0);
}

static void
slingshot_app_context_menu_plank_menuitem_activate (SlingshotAppContextMenu* self)
{
	gboolean _tmp0_ = FALSE;
	PlankDBusClient* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = slingshot_app_context_menu_plank_client;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		PlankDBusClient* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp2_ = slingshot_app_context_menu_plank_client;
		_tmp3_ = plank_dbus_client_get_is_connected (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = !_tmp4_;
	}
	if (_tmp0_) {
		return;
	}
	if (self->priv->docked) {
		PlankDBusClient* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		_tmp5_ = slingshot_app_context_menu_plank_client;
		_tmp6_ = slingshot_app_context_menu_get_desktop_uri (self);
		_tmp7_ = _tmp6_;
		_tmp8_ = _tmp7_;
		plank_dbus_client_remove_item (_tmp5_, _tmp8_);
		_g_free0 (_tmp8_);
	} else {
		PlankDBusClient* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp9_ = slingshot_app_context_menu_plank_client;
		_tmp10_ = slingshot_app_context_menu_get_desktop_uri (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_;
		plank_dbus_client_add_item (_tmp9_, _tmp12_);
		_g_free0 (_tmp12_);
	}
}

const gchar*
slingshot_app_context_menu_get_desktop_id (SlingshotAppContextMenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_desktop_id;
	result = _tmp0_;
	return result;
}

static void
slingshot_app_context_menu_set_desktop_id (SlingshotAppContextMenu* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = slingshot_app_context_menu_get_desktop_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_desktop_id);
		self->priv->_desktop_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY]);
	}
}

const gchar*
slingshot_app_context_menu_get_desktop_path (SlingshotAppContextMenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_desktop_path;
	result = _tmp0_;
	return result;
}

static void
slingshot_app_context_menu_set_desktop_path (SlingshotAppContextMenu* self,
                                             const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = slingshot_app_context_menu_get_desktop_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_desktop_path);
		self->priv->_desktop_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY]);
	}
}

static gchar*
slingshot_app_context_menu_get_desktop_uri (SlingshotAppContextMenu* self)
{
	gchar* result;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_desktop_path;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_uri (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		SlingshotAppContextMenu* self;
		self = _data7_->self;
		_g_free0 (_data7_->action);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_slingshot_app_context_menu_____lambda35_ (Block7Data* _data7_)
{
	SlingshotAppContextMenu* self;
	GDesktopAppInfo* _tmp0_;
	const gchar* _tmp1_;
	GAppLaunchContext* _tmp2_;
	GAppLaunchContext* _tmp3_;
	self = _data7_->self;
	_tmp0_ = self->priv->app_info;
	_tmp1_ = _data7_->action;
	_tmp2_ = g_app_launch_context_new ();
	_tmp3_ = _tmp2_;
	g_desktop_app_info_launch_action (_tmp0_, _tmp1_, _tmp3_);
	_g_object_unref0 (_tmp3_);
	g_signal_emit (self, slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL], 0);
}

static void
__slingshot_app_context_menu_____lambda35__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                   gpointer self)
{
	_slingshot_app_context_menu_____lambda35_ (self);
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_slingshot_app_context_menu_plank_menuitem_activate_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                            gpointer self)
{
	slingshot_app_context_menu_plank_menuitem_activate ((SlingshotAppContextMenu*) self);
}

static GObject *
slingshot_app_context_menu_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SlingshotAppContextMenu * self;
	const gchar* _tmp0_;
	GDesktopAppInfo* _tmp1_;
	GDesktopAppInfo* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gboolean _tmp15_ = FALSE;
	PlankDBusClient* _tmp16_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gboolean _tmp39_;
	parent_class = G_OBJECT_CLASS (slingshot_app_context_menu_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
	_tmp0_ = self->priv->_desktop_id;
	_tmp1_ = g_desktop_app_info_new (_tmp0_);
	_g_object_unref0 (self->priv->app_info);
	self->priv->app_info = _tmp1_;
	_tmp2_ = self->priv->app_info;
	_tmp4_ = _tmp3_ = g_desktop_app_info_list_actions (_tmp2_);
	{
		gchar** _action_collection = NULL;
		gint _action_collection_length1 = 0;
		gint __action_collection_size_ = 0;
		gint _action_it = 0;
		_action_collection = _tmp4_;
		_action_collection_length1 = _vala_array_length (_tmp3_);
		for (_action_it = 0; _action_it < _action_collection_length1; _action_it = _action_it + 1) {
			const gchar* _action = NULL;
			_action = _action_collection[_action_it];
			{
				Block7Data* _data7_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
				GtkMenuItem* menuitem = NULL;
				GDesktopAppInfo* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				GtkMenuItem* _tmp11_;
				GtkMenuItem* _tmp12_;
				GtkMenuItem* _tmp13_;
				GtkMenuItem* _tmp14_;
				_data7_ = g_slice_new0 (Block7Data);
				_data7_->_ref_count_ = 1;
				_data7_->self = g_object_ref (self);
				_tmp5_ = _action;
				_tmp6_ = g_strdup (_tmp5_);
				_data7_->action = _tmp6_;
				_tmp7_ = self->priv->app_info;
				_tmp8_ = _data7_->action;
				_tmp9_ = g_desktop_app_info_get_action_name (_tmp7_, _tmp8_);
				_tmp10_ = _tmp9_;
				_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_tmp10_);
				g_object_ref_sink (_tmp11_);
				_tmp12_ = _tmp11_;
				_g_free0 (_tmp10_);
				menuitem = _tmp12_;
				_tmp13_ = menuitem;
				gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
				_tmp14_ = menuitem;
				g_signal_connect_data (_tmp14_, "activate", (GCallback) __slingshot_app_context_menu_____lambda35__gtk_menu_item_activate, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
				_g_object_unref0 (menuitem);
				block7_data_unref (_data7_);
				_data7_ = NULL;
			}
		}
	}
	_tmp16_ = slingshot_app_context_menu_plank_client;
	if (_tmp16_ != NULL) {
		PlankDBusClient* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
		_tmp17_ = slingshot_app_context_menu_plank_client;
		_tmp18_ = plank_dbus_client_get_is_connected (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp15_ = _tmp19_;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		GList* _tmp20_;
		GList* _tmp21_;
		gboolean _tmp22_;
		GtkMenuItem* plank_menuitem = NULL;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		PlankDBusClient* _tmp30_;
		gint _tmp31_ = 0;
		gchar** _tmp32_;
		GtkMenuItem* _tmp35_;
		GtkMenuItem* _tmp36_;
		_tmp20_ = gtk_container_get_children ((GtkContainer*) self);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_list_length (_tmp21_) > ((guint) 0);
		(_tmp21_ == NULL) ? NULL : (_tmp21_ = (g_list_free (_tmp21_), NULL));
		if (_tmp22_) {
			GtkSeparatorMenuItem* _tmp23_;
			GtkSeparatorMenuItem* _tmp24_;
			_tmp23_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp23_);
			_tmp24_ = _tmp23_;
			gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
			_g_object_unref0 (_tmp24_);
		}
		self->priv->has_system_item = TRUE;
		_tmp25_ = (GtkMenuItem*) gtk_menu_item_new ();
		g_object_ref_sink (_tmp25_);
		plank_menuitem = _tmp25_;
		_tmp26_ = plank_menuitem;
		gtk_menu_item_set_use_underline (_tmp26_, TRUE);
		_tmp27_ = slingshot_app_context_menu_get_desktop_uri (self);
		_tmp28_ = _tmp27_;
		_tmp29_ = _tmp28_;
		_tmp30_ = slingshot_app_context_menu_plank_client;
		_tmp32_ = plank_dbus_client_get_persistent_applications (_tmp30_, &_tmp31_);
		self->priv->docked = _vala_string_array_contains (_tmp32_, _tmp31_, _tmp29_);
		_g_free0 (_tmp29_);
		if (self->priv->docked) {
			GtkMenuItem* _tmp33_;
			_tmp33_ = plank_menuitem;
			gtk_menu_item_set_label (_tmp33_, _ ("Remove from _Dock"));
		} else {
			GtkMenuItem* _tmp34_;
			_tmp34_ = plank_menuitem;
			gtk_menu_item_set_label (_tmp34_, _ ("Add to _Dock"));
		}
		_tmp35_ = plank_menuitem;
		g_signal_connect_object (_tmp35_, "activate", (GCallback) _slingshot_app_context_menu_plank_menuitem_activate_gtk_menu_item_activate, self, 0);
		_tmp36_ = plank_menuitem;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp36_);
		_g_object_unref0 (plank_menuitem);
	}
	_tmp37_ = g_find_program_in_path ("io.elementary.appcenter");
	_tmp38_ = _tmp37_;
	_tmp39_ = _tmp38_ != NULL;
	_g_free0 (_tmp38_);
	if (_tmp39_) {
		gboolean _tmp40_ = FALSE;
		if (!self->priv->has_system_item) {
			GList* _tmp41_;
			GList* _tmp42_;
			_tmp41_ = gtk_container_get_children ((GtkContainer*) self);
			_tmp42_ = _tmp41_;
			_tmp40_ = g_list_length (_tmp42_) > ((guint) 0);
			(_tmp42_ == NULL) ? NULL : (_tmp42_ = (g_list_free (_tmp42_), NULL));
		} else {
			_tmp40_ = FALSE;
		}
		if (_tmp40_) {
			GtkSeparatorMenuItem* _tmp43_;
			GtkSeparatorMenuItem* _tmp44_;
			_tmp43_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
			g_object_ref_sink (_tmp43_);
			_tmp44_ = _tmp43_;
			gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp44_);
			_g_object_unref0 (_tmp44_);
		}
	}
	gtk_widget_show_all ((GtkWidget*) self);
	return obj;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
slingshot_app_context_menu_class_init (SlingshotAppContextMenuClass * klass,
                                       gpointer klass_data)
{
	PlankDBusClient* _tmp0_;
	PlankDBusClient* _tmp1_;
	slingshot_app_context_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SlingshotAppContextMenu_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_slingshot_app_context_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_slingshot_app_context_menu_set_property;
	G_OBJECT_CLASS (klass)->constructor = slingshot_app_context_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = slingshot_app_context_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY] = g_param_spec_string ("desktop-id", "desktop-id", "desktop-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY, slingshot_app_context_menu_properties[SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY] = g_param_spec_string ("desktop-path", "desktop-path", "desktop-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	slingshot_app_context_menu_signals[SLINGSHOT_APP_CONTEXT_MENU_APP_LAUNCHED_SIGNAL] = g_signal_new ("app-launched", SLINGSHOT_TYPE_APP_CONTEXT_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	plank_paths_initialize ("plank", PKGDATADIR);
	_tmp0_ = plank_dbus_client_get_instance ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (slingshot_app_context_menu_plank_client);
	slingshot_app_context_menu_plank_client = _tmp1_;
}

static void
slingshot_app_context_menu_instance_init (SlingshotAppContextMenu * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
	self->priv = slingshot_app_context_menu_get_instance_private (self);
	self->priv->has_system_item = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->appstream_comp_id = _tmp0_;
	self->priv->docked = FALSE;
}

static void
slingshot_app_context_menu_finalize (GObject * obj)
{
	SlingshotAppContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
	_g_free0 (self->priv->_desktop_id);
	_g_free0 (self->priv->_desktop_path);
	_g_object_unref0 (self->priv->app_info);
	_g_free0 (self->priv->appstream_comp_id);
	_g_object_unref0 (self->priv->uninstall_menuitem);
	_g_object_unref0 (self->priv->appcenter_menuitem);
	G_OBJECT_CLASS (slingshot_app_context_menu_parent_class)->finalize (obj);
}

GType
slingshot_app_context_menu_get_type (void)
{
	return slingshot_app_context_menu_type_id;
}

GType
slingshot_app_context_menu_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SlingshotAppContextMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slingshot_app_context_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SlingshotAppContextMenu), 0, (GInstanceInitFunc) slingshot_app_context_menu_instance_init, NULL };
	slingshot_app_context_menu_type_id = g_type_module_register_type (module, gtk_menu_get_type (), "SlingshotAppContextMenu", &g_define_type_info, 0);
	SlingshotAppContextMenu_private_offset = sizeof (SlingshotAppContextMenuPrivate);
	return slingshot_app_context_menu_type_id;
}

static void
_vala_slingshot_app_context_menu_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SlingshotAppContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
	switch (property_id) {
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY:
		g_value_set_string (value, slingshot_app_context_menu_get_desktop_id (self));
		break;
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY:
		g_value_set_string (value, slingshot_app_context_menu_get_desktop_path (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_slingshot_app_context_menu_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SlingshotAppContextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SLINGSHOT_TYPE_APP_CONTEXT_MENU, SlingshotAppContextMenu);
	switch (property_id) {
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_ID_PROPERTY:
		slingshot_app_context_menu_set_desktop_id (self, g_value_get_string (value));
		break;
		case SLINGSHOT_APP_CONTEXT_MENU_DESKTOP_PATH_PROPERTY:
		slingshot_app_context_menu_set_desktop_path (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

