/* RunnerAction.c generated by valac 0.54.6, the Vala compiler
 * generated from RunnerAction.vala, do not modify */

/*
* Copyright (c) 2010 Michal Hruby <michal.mhr@gmail.com>
*               2017 elementary LLC.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Michal Hruby <michal.mhr@gmail.com>
*/

#include "slingshot.h"
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gdk/gdk.h>

#define SYNAPSE_TYPE_RUNNER_ACTION (synapse_runner_action_get_type ())
#define SYNAPSE_RUNNER_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SYNAPSE_TYPE_RUNNER_ACTION, SynapseRunnerAction))
#define SYNAPSE_RUNNER_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SYNAPSE_TYPE_RUNNER_ACTION, SynapseRunnerActionClass))
#define SYNAPSE_IS_RUNNER_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SYNAPSE_TYPE_RUNNER_ACTION))
#define SYNAPSE_IS_RUNNER_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SYNAPSE_TYPE_RUNNER_ACTION))
#define SYNAPSE_RUNNER_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SYNAPSE_TYPE_RUNNER_ACTION, SynapseRunnerActionClass))

typedef struct _SynapseRunnerAction SynapseRunnerAction;
typedef struct _SynapseRunnerActionClass SynapseRunnerActionClass;
typedef struct _SynapseRunnerActionPrivate SynapseRunnerActionPrivate;
enum  {
	SYNAPSE_RUNNER_ACTION_0_PROPERTY,
	SYNAPSE_RUNNER_ACTION_NUM_PROPERTIES
};
static GParamSpec* synapse_runner_action_properties[SYNAPSE_RUNNER_ACTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SynapseRunnerAction {
	SynapseBaseAction parent_instance;
	SynapseRunnerActionPrivate * priv;
};

struct _SynapseRunnerActionClass {
	SynapseBaseActionClass parent_class;
};

static gpointer synapse_runner_action_parent_class = NULL;
static GType synapse_runner_action_type_id = 0;

GType synapse_runner_action_register_type (GTypeModule * module);
VALA_EXTERN GType synapse_runner_action_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SynapseRunnerAction* synapse_runner_action_new (void);
VALA_EXTERN SynapseRunnerAction* synapse_runner_action_construct (GType object_type);
static void synapse_runner_action_real_do_execute (SynapseBaseAction* base,
                                            SynapseMatch* match,
                                            SynapseMatch* target);
static void _____lambda25_ (SynapseRunnerAction* self,
                     GPid pid,
                     gint status);
static void ______lambda25__gchild_watch_func (GPid pid,
                                        gint wait_status,
                                        gpointer self);
static gboolean synapse_runner_action_real_valid_for_match (SynapseBaseAction* base,
                                                     SynapseMatch* match);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

SynapseRunnerAction*
synapse_runner_action_construct (GType object_type)
{
	SynapseRunnerAction * self = NULL;
	self = (SynapseRunnerAction*) g_object_new (object_type, "title", _ ("Run"), "description", _ ("Run an application, action or script"), "icon-name", "system-run", "has-thumbnail", FALSE, "match-type", SYNAPSE_MATCH_TYPE_ACTION, "default-relevancy", SYNAPSE_MATCH_SCORE_EXCELLENT, NULL);
	return self;
}

SynapseRunnerAction*
synapse_runner_action_new (void)
{
	return synapse_runner_action_construct (SYNAPSE_TYPE_RUNNER_ACTION);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
_____lambda25_ (SynapseRunnerAction* self,
                GPid pid,
                gint status)
{
	g_spawn_close_pid (pid);
}

static void
______lambda25__gchild_watch_func (GPid pid,
                                   gint wait_status,
                                   gpointer self)
{
	_____lambda25_ ((SynapseRunnerAction*) self, pid, wait_status);
}

static void
synapse_runner_action_real_do_execute (SynapseBaseAction* base,
                                       SynapseMatch* match,
                                       SynapseMatch* target)
{
	SynapseRunnerAction * self;
	SynapseMatchType _tmp0_;
	SynapseMatchType _tmp1_;
	GError* _inner_error0_ = NULL;
	self = (SynapseRunnerAction*) base;
	_tmp0_ = synapse_match_get_match_type (match);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == SYNAPSE_MATCH_TYPE_APPLICATION) {
		SynapseApplicationMatch* app_match = NULL;
		SynapseApplicationMatch* _tmp2_;
		GAppInfo* _tmp3_ = NULL;
		SynapseApplicationMatch* _tmp4_;
		GAppInfo* _tmp5_;
		GAppInfo* _tmp6_;
		GAppInfo* _tmp7_;
		GAppInfo* app = NULL;
		GAppInfo* _tmp12_;
		app_match = SYNAPSE_IS_APPLICATION_MATCH (match) ? ((SynapseApplicationMatch*) match) : NULL;
		_tmp2_ = app_match;
		g_return_if_fail (_tmp2_ != NULL);
		_tmp4_ = app_match;
		_tmp5_ = synapse_application_match_get_app_info (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_tmp3_ = _tmp7_;
		if (_tmp3_ == NULL) {
			SynapseApplicationMatch* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			GDesktopAppInfo* _tmp11_;
			_tmp8_ = app_match;
			_tmp9_ = synapse_application_match_get_filename (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_desktop_app_info_new_from_filename (_tmp10_);
			_g_object_unref0 (_tmp3_);
			_tmp3_ = (GAppInfo*) _tmp11_;
		}
		_tmp12_ = _tmp3_;
		_tmp3_ = NULL;
		app = _tmp12_;
		{
			GdkDisplay* display = NULL;
			GdkDisplay* _tmp13_;
			gchar* commandline = NULL;
			GAppInfo* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar** spawn_args = NULL;
			gchar** _tmp17_;
			gint spawn_args_length1;
			gint _spawn_args_size_;
			static const char checkstr[] = "pkexec";
			const gchar* _tmp18_;
			gboolean _tmp22_ = FALSE;
			gchar** _tmp23_;
			gint _tmp23__length1;
			SynapseRelevancyService* _tmp35_;
			SynapseRelevancyService* _tmp36_;
			GAppInfo* _tmp37_;
			_tmp13_ = gdk_display_get_default ();
			display = _tmp13_;
			_tmp14_ = app;
			_tmp15_ = g_app_info_get_commandline (_tmp14_);
			_tmp16_ = g_strdup (_tmp15_);
			commandline = _tmp16_;
			_tmp17_ = g_new0 (gchar*, 0 + 1);
			spawn_args = _tmp17_;
			spawn_args_length1 = 0;
			_spawn_args_size_ = spawn_args_length1;
			_tmp18_ = commandline;
			if (string_contains (_tmp18_, checkstr)) {
				const gchar* _tmp19_;
				gchar** _tmp20_;
				gchar** _tmp21_;
				_tmp19_ = commandline;
				_tmp21_ = _tmp20_ = g_strsplit (_tmp19_, " ", 0);
				spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
				spawn_args = _tmp21_;
				spawn_args_length1 = _vala_array_length (_tmp20_);
				_spawn_args_size_ = spawn_args_length1;
			}
			_tmp23_ = spawn_args;
			_tmp23__length1 = spawn_args_length1;
			if (_tmp23__length1 >= 2) {
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				_tmp24_ = spawn_args;
				_tmp24__length1 = spawn_args_length1;
				_tmp25_ = _tmp24_[0];
				_tmp22_ = g_strcmp0 (_tmp25_, checkstr) == 0;
			} else {
				_tmp22_ = FALSE;
			}
			if (_tmp22_) {
				gchar** spawn_env = NULL;
				gchar** _tmp26_;
				gchar** _tmp27_;
				gint spawn_env_length1;
				gint _spawn_env_size_;
				GPid child_pid = 0;
				gchar** _tmp28_;
				gint _tmp28__length1;
				gchar** _tmp29_;
				gint _tmp29__length1;
				GPid _tmp30_ = 0;
				_tmp27_ = _tmp26_ = g_get_environ ();
				spawn_env = _tmp27_;
				spawn_env_length1 = _vala_array_length (_tmp26_);
				_spawn_env_size_ = spawn_env_length1;
				_tmp28_ = spawn_args;
				_tmp28__length1 = spawn_args_length1;
				_tmp29_ = spawn_env;
				_tmp29__length1 = spawn_env_length1;
				g_spawn_async ("/", _tmp28_, _tmp29_, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp30_, &_inner_error0_);
				child_pid = _tmp30_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
					spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (commandline);
					goto __catch0_g_error;
				}
				g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, child_pid, ______lambda25__gchild_watch_func, g_object_ref (self), g_object_unref);
				spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
			} else {
				GAppInfo* _tmp31_;
				GdkDisplay* _tmp32_;
				GdkAppLaunchContext* _tmp33_;
				GdkAppLaunchContext* _tmp34_;
				_tmp31_ = app;
				_tmp32_ = display;
				_tmp33_ = gdk_display_get_app_launch_context (_tmp32_);
				_tmp34_ = _tmp33_;
				g_app_info_launch (_tmp31_, NULL, (GAppLaunchContext*) _tmp34_, &_inner_error0_);
				_g_object_unref0 (_tmp34_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (commandline);
					goto __catch0_g_error;
				}
			}
			_tmp35_ = synapse_relevancy_service_get_default ();
			_tmp36_ = _tmp35_;
			_tmp37_ = app;
			synapse_relevancy_service_application_launched (_tmp36_, _tmp37_);
			_g_object_unref0 (_tmp36_);
			spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (commandline);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp38_;
			const gchar* _tmp39_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp38_ = err;
			_tmp39_ = _tmp38_->message;
			g_critical ("RunnerAction.vala:70: %s", _tmp39_);
			_g_error_free0 (err);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (app);
			_g_object_unref0 (_tmp3_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_g_object_unref0 (app);
		_g_object_unref0 (_tmp3_);
	} else {
		synapse_match_execute (match, NULL);
	}
}

static gboolean
synapse_runner_action_real_valid_for_match (SynapseBaseAction* base,
                                            SynapseMatch* match)
{
	SynapseRunnerAction * self;
	SynapseMatchType _tmp0_;
	SynapseMatchType _tmp1_;
	gboolean result = FALSE;
	self = (SynapseRunnerAction*) base;
	g_return_val_if_fail (match != NULL, FALSE);
	_tmp0_ = synapse_match_get_match_type (match);
	_tmp1_ = _tmp0_;
	switch (_tmp1_) {
		case SYNAPSE_MATCH_TYPE_SEARCH:
		{
			result = TRUE;
			return result;
		}
		case SYNAPSE_MATCH_TYPE_ACTION:
		{
			result = TRUE;
			return result;
		}
		case SYNAPSE_MATCH_TYPE_APPLICATION:
		{
			SynapseApplicationMatch* am = NULL;
			gboolean _tmp2_ = FALSE;
			SynapseApplicationMatch* _tmp3_;
			am = SYNAPSE_IS_APPLICATION_MATCH (match) ? ((SynapseApplicationMatch*) match) : NULL;
			_tmp3_ = am;
			if (_tmp3_ == NULL) {
				_tmp2_ = TRUE;
			} else {
				SynapseApplicationMatch* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
				_tmp4_ = am;
				_tmp5_ = synapse_application_match_get_needs_terminal (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp2_ = !_tmp6_;
			}
			result = _tmp2_;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}

static void
synapse_runner_action_class_init (SynapseRunnerActionClass * klass,
                                  gpointer klass_data)
{
	synapse_runner_action_parent_class = g_type_class_peek_parent (klass);
	((SynapseBaseActionClass *) klass)->do_execute = (void (*) (SynapseBaseAction*, SynapseMatch*, SynapseMatch*)) synapse_runner_action_real_do_execute;
	((SynapseBaseActionClass *) klass)->valid_for_match = (gboolean (*) (SynapseBaseAction*, SynapseMatch*)) synapse_runner_action_real_valid_for_match;
}

static void
synapse_runner_action_instance_init (SynapseRunnerAction * self,
                                     gpointer klass)
{
}

GType
synapse_runner_action_get_type (void)
{
	return synapse_runner_action_type_id;
}

GType
synapse_runner_action_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (SynapseRunnerActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) synapse_runner_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SynapseRunnerAction), 0, (GInstanceInitFunc) synapse_runner_action_instance_init, NULL };
	synapse_runner_action_type_id = g_type_module_register_type (module, SYNAPSE_TYPE_BASE_ACTION, "SynapseRunnerAction", &g_define_type_info, 0);
	return synapse_runner_action_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

